<?php

namespace Teknisa\CADFIN\Factories;

use Doctrine\ORM\EntityManager;

class Pag41100ContaPagarFactory {
  
    protected $connection;

    public function __construct(EntityManager $entityManager) {
      $this->connection = $entityManager->getConnection();
    }
    
    public function findNvMaxContctbl() { 
        $sql = "SELECT LENGTH(REGEXP_REPLACE(CDPICTCCTB, '[^\.]')) + 1 AS NVMAXCONTCTBL FROM PARAMGERAL";
    
        $std = $this->connection->prepare($sql);
        $params = array();
        $std->execute($params);
    
        return $std->fetch();
    }
    
    public function selectEmpresa($cdempresa,$cdtpctpagar) { 
    
        $sql = "SELECT * FROM EMPRTPCTPAG 
                 WHERE CDEMPRESA = :CDEMPRESA 
                 AND CDTPCTPAGAR = :CDTPCTPAGAR";
        
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "CDEMPRESA"       => $cdempresa,
            "CDTPCTPAGAR"     => $cdtpctpagar,
        );
        
        $std->execute($params);
        
        return $std->fetch();
        
    }
  
    public function saveEmpresa($params) {
        // Query a ser executada.
        $sql = "INSERT INTO EMPRTPCTPAG (CDEMPRESA,
                                        CDOPERINCLUSAO, 
                                        CDOPERULTATU, 
                                        CDTPCTPAGAR, 
                                        DTINCLUSAO, 
                                        DTULTATU, 
                                        IDATIVO, 
                                        NRORG, 
                                        NRORGINCLUSAO, 
                                        NRORGULTATU) 
                              VALUES (  :CDEMPRESA, 
                                        :CDOPERINCLUSAO, 
                                        :CDOPERULTATU, 
                                        :CDTPCTPAGAR, 
                                        :DTINCLUSAO, 
                                        :DTULTATU, 
                                        :IDATIVO, 
                                        :NRORG, 
                                        :NRORGINCLUSAO, 
                                        :NRORGULTATU)";

        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
    } 
  
    public function deleteEmpresa($cdtpctpagar) {
        // Query a ser executada.
        $sql = "DELETE FROM EMPRTPCTPAG WHERE CDTPCTPAGAR = :CDTPCTPAGAR";

        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        $params = array(
            "CDTPCTPAGAR"     => $cdtpctpagar,
        );
    
    
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
    } 

}