<?php

namespace Teknisa\CADFIN\Services;

use Teknisa\CADFIN\Factories\Rec41100TipoCtReceberFactory;

class Rec41100TipoCtReceberService {
  
  protected $Rec41100TipoCtReceberFactory; 
  
  public function __construct(Rec41100TipoCtReceberFactory $Rec41100TipoCtReceberFactory) {
    $this->Rec41100TipoCtReceberFactory = $Rec41100TipoCtReceberFactory;
  }
  
  public function getNvMaxContctbl() {
    
    return $this->Rec41100TipoCtReceberFactory->findNvMaxContctbl();
    
  }
  
  public function saveEmpresa($row) {
    try{
      $arrayCdempresa = $row['CDEMPRESA'];
      $nrorg = $row['NRORG'];
      $operador = $row['CDOPERADOR']; 
      $i = 0;
      foreach ($arrayCdempresa as $cdempresa){
          $selectEmpresa = $this->Rec41100TipoCtReceberFactory->selectEmpresa($cdempresa, $row['CDTPCTRECEB']);
          if(empty($selectEmpresa)){
            $params = array(
              "CDEMPRESA"       => $cdempresa,
              "CDOPERINCLUSAO"  => $operador,
              "CDOPERULTATU"    => $operador,
              "CDTPCTRECEB"     => $row['CDTPCTRECEB'],
              "DTINCLUSAO"      => $row['DATA'],
              "DTULTATU"        => $row['DATA'],
              "IDATIVO"         => 'S',
              "NRORG"           => $nrorg,
              "NRORGINCLUSAO"   => $nrorg,
              "NRORGULTATU"     => $nrorg
            );
            $i++;
            
            $this->Rec41100TipoCtReceberFactory->saveEmpresa($params);
          }
      }
      
    } catch(\Exception $e) {
        throw $e;
    }
    
  }
  
  public function cadastroAutomaticoEmpresa($row) {
    try{
      
      $arrayTipoContRec = $row["CDTPCTRECEB"];
      
      foreach($arrayTipoContRec as $tipoContRec){
          $rowToSave = $row;
          $rowToSave['CDTPCTRECEB'] = $tipoContRec;
          if($row['IDOPERACAO'] === 'I'){
            $this->saveEmpresa($row);
          } 
          else if($row['IDOPERACAO'] === 'S'){
            $this->Rec41100TipoCtReceberFactory->deleteEmpresa($rowToSave['CDTPCTRECEB']);
            
            $this->saveEmpresa($row);
          }
          
      }
      
    } catch(\Exception $e) {
        throw $e;
    }
    
  }
  
}
